#version 120
// (C) 2009 Dmytry Lavrov. All rights reserved.
uniform vec2 d0;
uniform vec2 d1;
uniform vec2 d2;
uniform vec2 d3;

uniform vec3 c0;
uniform vec3 c1;
uniform vec3 c2;
uniform vec3 c3;
uniform vec3 c4;

varying vec2 texture_coordinate;
uniform sampler2D my_color_texture;

const float discoloration=0.01;


void main()
{

  vec3 t0=texture2D(my_color_texture, texture_coordinate+d0).rgb;
  vec3 t1=texture2D(my_color_texture, texture_coordinate+d1).rgb;
  vec3 t2=texture2D(my_color_texture, texture_coordinate+d2).rgb;
  vec3 t3=texture2D(my_color_texture, texture_coordinate+d3).rgb;
/*
	vec3 tmp=
	texture2D(my_color_texture, texture_coordinate+d0).rgb*c0+
	texture2D(my_color_texture, texture_coordinate+d1).rgb*c1+
	texture2D(my_color_texture, texture_coordinate+d2).rgb*c2+
	texture2D(my_color_texture, texture_coordinate+d3).rgb*c3+
	c4;
	*/
	vec3 tmp1=t0*c0+t1*c1+t2*c2+t3*c3;
	vec3 tmp2=min(min(t0,t1),min(t2,t3));
	vec3 tmp3=max(max(t0,t1),max(t2,t3));

	//vec3 tmp=0.5*tmp1+0.5*tmp2+c4;
	vec3 tmp=tmp1*0.1+tmp2*0.8+tmp3*0.1+c4;
	//vec3 tmp=tmp1;
	//vec3 tmp=tmp1*0.33333+tmp2*0.333333+tmp3*0.333333+c4;

	float a=(tmp.r+tmp.g+tmp.b)/3.0;
	//tmp=tmp*0.98+vec3(a*0.02);
	tmp=tmp*(1.0-discoloration)+vec3(a*discoloration);
	//tmp=tmp+noise3(texture_coordinate*1000);

	gl_FragColor = vec4(fract(tmp),1.0);
}
