#version 120
// (C) 2009 Dmytry Lavrov. All rights reserved.

uniform float brightness;

uniform mat4 color_matrix;

void main(void)
{
	vec4 pos = gl_ModelViewProjectionMatrix * gl_Vertex;
  vec3 delta=(gl_ModelViewMatrix*gl_Vertex).xyz;
  float l=dot(delta,delta);
  gl_Position=pos;
  vec3 c=vec3(color_matrix*gl_Vertex);
  c=abs(2.0*fract(c)-vec3(1.0,1.0,1.0));/// triangle wave
  gl_FrontColor=vec4(c*(brightness/l), 1.0);
}
