#version 120
// (C) 2009 Dmytry Lavrov. All rights reserved.
varying vec3 original_pos;
uniform sampler2D texture;
uniform float power;
uniform float brightness;
uniform vec2 offset;


void main()
{
	vec3 tpos=normalize(original_pos);
	vec3 col=texture2D(texture, vec2(0.5,0.5) + 0.25*(tpos.xy/(tpos.z-1.0)) + offset).xyz;

	//gl_FragColor = vec4((col*col)*0.2, 1);
	gl_FragColor = vec4(pow(col.r,power)*brightness, pow(col.g,power)*brightness, pow(col.b,power)*brightness , 1);
	//gl_FragColor = vec4(col*brightness , 1);
	//gl_FragColor = vec4((col*col*col)*0.7, 1);
}
