#version 120
// (C) 2009 Dmytry Lavrov. All rights reserved.
varying vec3 original_pos;
uniform sampler2D texture;
uniform sampler2D texture_old;
uniform float interp_t;


uniform float power;
uniform float brightness;

uniform float theta;

uniform vec3 phase;

void main()
{
	//vec3 tpos=normalize(original_pos)-vec3(0,0,1.00001);
	vec3 tpos=normalize(original_pos)-vec3(0.0,0.0,theta);
	vec2 pos=0.25*(tpos.xy/tpos.z);

	vec3 tpos2=normalize(original_pos)-vec3(0.0,0.0,-theta);
	vec2 pos2=0.25*(tpos2.xy/tpos2.z);

	vec3 col_cur=(texture2D(texture, pos).xyz   +texture2D(texture, pos2).xyz  );
	vec3 col_old=(texture2D(texture_old, pos).xyz   +texture2D(texture_old, pos2).xyz  );

	vec3 col=(col_old+(col_cur-col_old)*interp_t);

	col=fract(phase+col);

	col=vec3(1,1,1)-abs(col*2.0-vec3(1,1,1));

	//col=0.5+0.5*sin(col*4.0);

	//gl_FragColor = vec4((col*col)*0.2, 1);

	gl_FragColor = vec4(pow(col.r+0.001,power)*brightness, pow(col.g+0.001,power)*brightness, pow(col.b+0.001,power)*brightness , 1.0);

	//gl_FragColor = vec4(col*brightness , 1);
	//gl_FragColor = vec4((col*col*col)*0.7, 1);
}
