#version 120
// (C) 2009 Dmytry Lavrov. All rights reserved.
uniform vec2 d0;
uniform vec2 d1;
uniform vec2 d2;
uniform vec2 d3;
varying vec2 texture_coordinate;
uniform sampler2D my_color_texture;

void main()
{
	// blur from four samples
	gl_FragColor = 0.25*(
	texture2D(my_color_texture, texture_coordinate+d0)+
	texture2D(my_color_texture, texture_coordinate+d1)+
	texture2D(my_color_texture, texture_coordinate+d2)+
	texture2D(my_color_texture, texture_coordinate+d3)
	);
}
